#include <iostream>
#include <cmath>
#include <boost/math/quaternion.hpp>
using namespace std;
using namespace boost::math;

// x -> WA ϊ
double deg_to_rad( double deg )
{
    return deg * 3.141592653589793 / 180;
}

// (x,y,z)Ɋpxtheta]ϊ p̎l쐬
quaternion<double> rotater( double x, double y, double z, double theta )
{
    double c = cos(theta/2), s = sin(theta/2);
    quaternion<double> q( c, s*x, s*y, s*z );
    return q / abs(q);
}

int main()
{
    cout.setf( ios_base::fixed );
    cout.precision( 2 );

    // (1,1,1) 90x]ϊ
    quaternion<double> q = rotater( 1,1,1, deg_to_rad(90) );
    // xNg (2,0,0) \l
    quaternion<double> v( 0, 2, 0, 0 );

    // Sv
    for( int i=0; i!=4; ++i )
    {
        v = q * v * conj(q);
        cout << v << endl;
    }
    return 0;
}
