#include <iostream>
#include <boost/bind.hpp>
#include <boost/ref.hpp>
#include <boost/function.hpp>
using namespace std;
using namespace boost;

int add( int x, int y ) { return x + y; }

int main()
{
    int n = 5;
    // ϐn̒lbind
    function1<int, int> f = bind( &add,     n , _1 );
    // ϐnւ̎QƂbind
    function1<int, int> g = bind( &add, ref(n), _1 );
    n = 10;
    cout << f(3) << endl; // 5 + 3 vZ
    cout << g(3) << endl; // n + 3 vZ
    return 0;
}
