#include <iostream>
#include <boost/shared_ptr.hpp>
using namespace std;
using namespace boost;

class Test
{
public:
    Test( char id ) : id(id)
      { cout << id << " ̍\z" << endl; }
    ~Test()
      { cout << id << " ̔j" << endl; }
    void SayHello()
      { cout << id << " łBɂ" << endl; }
private:
    char id;
};

int main()
{
    shared_ptr<Test> ptr0;
    {
        shared_ptr<Test> ptr1( new Test('A') ); // 'A'\z
        shared_ptr<Test> ptr2( new Test('B') ); // 'B'\z
        shared_ptr<Test> ptr3( new Test('C') ); // 'C'\z
        ptr1->SayHello();   // 'A'̃o֐s
        ptr0 = ptr1 = ptr2; // ptr0ptr1A'B'w悤ɕύX
                            // ̎_'A'͂ǂQƂȂȂ
        ptr1->SayHello();   // ptr1̎w'B'̃o֐s
    }   // ptr3XR[v甲̂ŁA'C'͂ǂQƂȂȂ
        // ptr2XR[v甲邪Aptr0܂QƂĂ̂'B'͐
    ptr0->SayHello(); // ptr0̎w'B'̃o֐s
    return 0;
}   // ptr0XR[v甲̂ŁA'B'ǂQƂȂȂ
